﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace utca
{
    class Haz
    {
        public int Szam { get; set; }
        public char Szin { get; set; }
        public string Kerites { get; set; }
        public string Hazszam { get; set; }
        public Haz(int szam, int hossz, char szin)
        {
            Szam = szam;
            Szin = szin;
            Kerites = "";
            for (int i = 0; i < hossz; i++)
            {
                Kerites += szin;
            }
            Hazszam = szam.ToString();
            for (int i = Hazszam.Length; i < hossz; i++)
            {
                Hazszam += " ";
            }

        }

    }

    class Program
    {
        static List<Haz> utca = new List<Haz>();
        static void Main(string[] args)
        {

            /*1. feladat*/
            List<int> paros = new List<int>();
            int lastps = 0;
            List<int> paratlan = new List<int>();
            int lastpt = -1;

            StreamReader sr = new StreamReader("kerites.txt");
            while (!sr.EndOfStream)
            {
                string[] sor = sr.ReadLine().Split(' ');
                if (sor[0] == "0")
                {
                    lastps += 2;
                    paros.Add(utca.Count);
                    utca.Add(new Haz(lastps, int.Parse(sor[1]), sor[2][0]));
                }
                else
                {
                    lastpt += 2;
                    paratlan.Add(utca.Count);
                    utca.Add(new Haz(lastpt, int.Parse(sor[1]), sor[2][0]));
                }
            }

            sr.Close();

            Console.WriteLine("2. feladat");
            Console.WriteLine("Az eladott telkek szama: {0}", utca.Count);
            Console.WriteLine();
            Console.WriteLine("3. feladat");
            int idLast = utca.Count - 1;
            Console.WriteLine("A {0} oldalon adtak el az utolso telket.", utca[idLast].Szam % 2 == 0 ? "paros" : "paratlan");
            Console.WriteLine("Az utolsó telek házszáma: {0}", utca[idLast].Szam);
            Console.WriteLine();
            Console.WriteLine("4. feladat");
            Console.WriteLine("A szomszédossal egyezik a kerítés színe: {0}", EgyezoSzin(paratlan));
            Console.WriteLine();
            Console.WriteLine("5. feladat");
            Console.Write("Adjon meg egy házszámot! "); //83
            int szam = int.Parse(Console.ReadLine());
            if (szam % 2 == 0)
            {
                KeritesFestes(paros, (szam - 2) / 2);
            }
            else
            {
                KeritesFestes(paratlan, (szam - 1) / 2);
            }
            /*6. feladat*/
            Utcakep(paratlan);
            Console.ReadLine();
        }

        private static void Utcakep(List<int> oldal)
        {
            StreamWriter sw = new StreamWriter("utcakep.txt");
            for (int i = 0; i < oldal.Count; i++)
            {
                sw.Write(utca[oldal[i]].Kerites);
            }
            sw.WriteLine();
            for (int i = 0; i < oldal.Count; i++)
            {
                sw.Write(utca[oldal[i]].Hazszam);
            }

            sw.Close();
        }

        private static void KeritesFestes(List<int> oldal, int v)
        {
            char aktszin = utca[oldal[v]].Szin;
            Console.WriteLine("A kerítés színe / állapota: {0}", aktszin );
            char elotte = v == 0 ? ':' : utca[oldal[v - 1]].Szin;
            char utana = v == oldal.Count - 1 ? ':' : utca[oldal[v + 1]].Szin;
            char szin;
            for (szin = 'A'; szin <= 'Z' &&
                (Ugyanolyan(szin, aktszin) || Ugyanolyan(szin, elotte) || Ugyanolyan(szin, utana)); szin++)
            {
            }

            Console.WriteLine("Egy lehetséges festési szín: {0}", szin);
        }

        private static int EgyezoSzin(List<int> oldal)
        {
            int i;
            for (i = 0; i < oldal.Count - 1 && !Ugyanolyan(utca[oldal[i]].Szin, utca[oldal[i+1]].Szin); i++)
            {

            }
            return utca[oldal[i]].Szam;
        }

        private static bool Ugyanolyan(char v, char w)
        {
            return v == w && v != '#' && v != ':' ;
        }
    }
}
